net.minecraft.client.renderer

## Class RenderGlobal

- java.lang.Object
- - net.minecraft.client.renderer.RenderGlobal

- All Implemented Interfaces:
    IWorldAccess

      public class RenderGlobal
      extends Object
      implements IWorldAccess

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `Map` | `damagedBlocks` Stores blocks currently being broken.
    `RenderBlocks` | `globalRenderBlocks` Global render blocks
    `Minecraft` | `mc` A reference to the Minecraft object.
    `RenderEngine` | `renderEngine` The RenderEngine instance used by RenderGlobal
    `WorldClient` | `theWorld`
    `List` | `tileEntities`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RenderGlobal(Minecraft par1Minecraft, RenderEngine par2RenderEngine)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `broadcastSound(int par1, int par2, int par3, int par4, int par5)`
    `void` | `clipRenderersByFrustum(ICamera par1ICamera, float par2)` Checks all renderers that previously weren't in the frustum and 1/16th of those that previously were in the frustum for frustum clipping Args: frustum, partialTickTime
    `void` | `deleteAllDisplayLists()` Deletes all display lists
    `void` | `destroyBlockPartially(int par1, int par2, int par3, int par4, int par5)` Starts (or continues) destroying a block with given ID at the given coordinates for the given partially destroyed value
    `EntityFX` | `doSpawnParticle(String par1Str, double par2, double par4, double par6, double par8, double par10, double par12)` Spawns a particle.
    `void` | `drawBlockBreaking(EntityPlayer par1EntityPlayer, MovingObjectPosition par2MovingObjectPosition, int par3, ItemStack par4ItemStack, float par5)`
    `void` | `drawBlockDamageTexture(Tessellator par1Tessellator, EntityLiving par2EntityPlayer, float par3)`
    `void` | `drawBlockDamageTexture(Tessellator par1Tessellator, EntityPlayer par2EntityPlayer, float par3)`
    `void` | `drawSelectionBox(EntityPlayer par1EntityPlayer, MovingObjectPosition par2MovingObjectPosition, int par3, ItemStack par4ItemStack, float par5)` Draws the selection box for the player.
    `String` | `getDebugInfoEntities()` Gets the entities info for use on the Debug screen
    `String` | `getDebugInfoRenders()` Gets the render info for use on the Debug screen
    `boolean` | `hasCloudFog(double par1, double par3, double par5, float par7)` Checks if the given position is to be rendered with cloud fog
    `void` | `loadRenderers()` Loads all the renderers and sets up the basic settings usage
    `void` | `markBlockForRenderUpdate(int par1, int par2, int par3)` On the client, re-renders this block.
    `void` | `markBlockForUpdate(int par1, int par2, int par3)` On the client, re-renders the block.
    `void` | `markBlockRangeForRenderUpdate(int par1, int par2, int par3, int par4, int par5, int par6)` On the client, re-renders all blocks in this range, inclusive.
    `void` | `markBlocksForUpdate(int par1, int par2, int par3, int par4, int par5, int par6)` Marks the blocks in the given range for update
    `void` | `onEntityCreate(Entity par1Entity)` Called on all IWorldAccesses when an entity is created or loaded.
    `void` | `onEntityDestroy(Entity par1Entity)` Called on all IWorldAccesses when an entity is unloaded or destroyed.
    `void` | `playAuxSFX(EntityPlayer par1EntityPlayer, int par2, int par3, int par4, int par5, int par6)` Plays a pre-canned sound effect along with potentially auxiliary data-driven one-shot behaviour (particles, etc).
    `void` | `playRecord(String par1Str, int par2, int par3, int par4)` Plays the specified record.
    `void` | `playSound(String par1Str, double par2, double par4, double par6, float par8, float par9)` Plays the specified sound.
    `void` | `playSoundToNearExcept(EntityPlayer par1EntityPlayer, String par2Str, double par3, double par5, double par7, float par9, float par10)` Plays sound to all near players except the player reference given
    `void` | `registerDestroyBlockIcons(IconRegister par1IconRegister)`
    `void` | `renderAllRenderLists(int par1, double par2)` Render all render lists
    `void` | `renderClouds(float par1)`
    `void` | `renderCloudsFancy(float par1)` Renders the 3d fancy clouds
    `void` | `renderEntities(Vec3 par1Vec3, ICamera par2ICamera, float par3)` Renders all entities within range and within the frustrum.
    `void` | `renderSky(float par1)` Renders the sky with the partial tick time.
    `void` | `setWorldAndLoadRenderers(WorldClient par1WorldClient)` set null to clear
    `int` | `sortAndRender(EntityLiving par1EntityLiving, int par2, double par3)` Sorts all renderers based on the passed in entity.
    `void` | `spawnParticle(String par1Str, double par2, double par4, double par6, double par8, double par10, double par12)` Spawns a particle.
    `void` | `updateClouds()`
    `boolean` | `updateRenderers(EntityLiving par1EntityLiving, boolean par2)` Updates some of the renderers sorted by distance from the player

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### tileEntities

          public List tileEntities

    - #### theWorld

          public WorldClient theWorld

    - #### renderEngine

          public final RenderEngine renderEngine

      The RenderEngine instance used by RenderGlobal

    - #### mc

          public Minecraft mc

      A reference to the Minecraft object.

    - #### globalRenderBlocks

          public RenderBlocks globalRenderBlocks

      Global render blocks

    - #### damagedBlocks

          public Map damagedBlocks

      Stores blocks currently being broken. Key is entity ID of the thing doing the breaking. Value is a DestroyBlockProgress

  - ### Constructor Detail

    - #### RenderGlobal

          public RenderGlobal(Minecraft par1Minecraft,
                      RenderEngine par2RenderEngine)

  - ### Method Detail

    - #### setWorldAndLoadRenderers

          public void setWorldAndLoadRenderers(WorldClient par1WorldClient)

      set null to clear

    - #### loadRenderers

          public void loadRenderers()

      Loads all the renderers and sets up the basic settings usage

    - #### renderEntities

          public void renderEntities(Vec3 par1Vec3,
                            ICamera par2ICamera,
                            float par3)

      Renders all entities within range and within the frustrum. Args: pos, frustrum, partialTickTime

    - #### getDebugInfoRenders

          public String getDebugInfoRenders()

      Gets the render info for use on the Debug screen

    - #### getDebugInfoEntities

          public String getDebugInfoEntities()

      Gets the entities info for use on the Debug screen

    - #### sortAndRender

          public int sortAndRender(EntityLiving par1EntityLiving,
                          int par2,
                          double par3)

      Sorts all renderers based on the passed in entity. Args: entityLiving, renderPass, partialTickTime

    - #### renderAllRenderLists

          public void renderAllRenderLists(int par1,
                                  double par2)

      Render all render lists

    - #### updateClouds

          public void updateClouds()

    - #### renderSky

          public void renderSky(float par1)

      Renders the sky with the partial tick time. Args: partialTickTime

    - #### renderClouds

          public void renderClouds(float par1)

    - #### hasCloudFog

          public boolean hasCloudFog(double par1,
                            double par3,
                            double par5,
                            float par7)

      Checks if the given position is to be rendered with cloud fog

    - #### renderCloudsFancy

          public void renderCloudsFancy(float par1)

      Renders the 3d fancy clouds

    - #### updateRenderers

          public boolean updateRenderers(EntityLiving par1EntityLiving,
                                boolean par2)

      Updates some of the renderers sorted by distance from the player

    - #### drawBlockBreaking

          public void drawBlockBreaking(EntityPlayer par1EntityPlayer,
                               MovingObjectPosition par2MovingObjectPosition,
                               int par3,
                               ItemStack par4ItemStack,
                               float par5)

    - #### drawBlockDamageTexture

          public void drawBlockDamageTexture(Tessellator par1Tessellator,
                                    EntityPlayer par2EntityPlayer,
                                    float par3)

    - #### drawBlockDamageTexture

          public void drawBlockDamageTexture(Tessellator par1Tessellator,
                                    EntityLiving par2EntityPlayer,
                                    float par3)

    - #### drawSelectionBox

          public void drawSelectionBox(EntityPlayer par1EntityPlayer,
                              MovingObjectPosition par2MovingObjectPosition,
                              int par3,
                              ItemStack par4ItemStack,
                              float par5)

      Draws the selection box for the player. Args: entityPlayer, rayTraceHit, i, itemStack, partialTickTime

    - #### markBlocksForUpdate

          public void markBlocksForUpdate(int par1,
                                 int par2,
                                 int par3,
                                 int par4,
                                 int par5,
                                 int par6)

      Marks the blocks in the given range for update

    - #### markBlockForUpdate

          public void markBlockForUpdate(int par1,
                                int par2,
                                int par3)

      On the client, re-renders the block. On the server, sends the block to the client (which will re-render it), including the tile entity description packet if applicable. Args: x, y, z
      Specified by:
        `markBlockForUpdate` in interface `IWorldAccess`

    - #### markBlockForRenderUpdate

          public void markBlockForRenderUpdate(int par1,
                                      int par2,
                                      int par3)

      On the client, re-renders this block. On the server, does nothing. Used for lighting updates.
      Specified by:
        `markBlockForRenderUpdate` in interface `IWorldAccess`

    - #### markBlockRangeForRenderUpdate

          public void markBlockRangeForRenderUpdate(int par1,
                                           int par2,
                                           int par3,
                                           int par4,
                                           int par5,
                                           int par6)

      On the client, re-renders all blocks in this range, inclusive. On the server, does nothing. Args: min x, min y, min z, max x, max y, max z
      Specified by:
        `markBlockRangeForRenderUpdate` in interface `IWorldAccess`

    - #### clipRenderersByFrustum

          public void clipRenderersByFrustum(ICamera par1ICamera,
                                    float par2)

      Checks all renderers that previously weren't in the frustum and 1/16th of those that previously were in the frustum for frustum clipping Args: frustum, partialTickTime

    - #### playRecord

          public void playRecord(String par1Str,
                        int par2,
                        int par3,
                        int par4)

      Plays the specified record. Arg: recordName, x, y, z
      Specified by:
        `playRecord` in interface `IWorldAccess`

    - #### playSound

          public void playSound(String par1Str,
                       double par2,
                       double par4,
                       double par6,
                       float par8,
                       float par9)

      Plays the specified sound. Arg: soundName, x, y, z, volume, pitch
      Specified by:
        `playSound` in interface `IWorldAccess`

    - #### playSoundToNearExcept

          public void playSoundToNearExcept(EntityPlayer par1EntityPlayer,
                                   String par2Str,
                                   double par3,
                                   double par5,
                                   double par7,
                                   float par9,
                                   float par10)

      Plays sound to all near players except the player reference given
      Specified by:
        `playSoundToNearExcept` in interface `IWorldAccess`

    - #### spawnParticle

          public void spawnParticle(String par1Str,
                           double par2,
                           double par4,
                           double par6,
                           double par8,
                           double par10,
                           double par12)

      Spawns a particle. Arg: particleType, x, y, z, velX, velY, velZ
      Specified by:
        `spawnParticle` in interface `IWorldAccess`

    - #### doSpawnParticle

          public EntityFX doSpawnParticle(String par1Str,
                                 double par2,
                                 double par4,
                                 double par6,
                                 double par8,
                                 double par10,
                                 double par12)

      Spawns a particle. Arg: particleType, x, y, z, velX, velY, velZ

    - #### onEntityCreate

          public void onEntityCreate(Entity par1Entity)

      Called on all IWorldAccesses when an entity is created or loaded. On client worlds, starts downloading any necessary textures. On server worlds, adds the entity to the entity tracker.
      Specified by:
        `onEntityCreate` in interface `IWorldAccess`

    - #### onEntityDestroy

          public void onEntityDestroy(Entity par1Entity)

      Called on all IWorldAccesses when an entity is unloaded or destroyed. On client worlds, releases any downloaded textures. On server worlds, removes the entity from the entity tracker.
      Specified by:
        `onEntityDestroy` in interface `IWorldAccess`

    - #### deleteAllDisplayLists

          public void deleteAllDisplayLists()

      Deletes all display lists

    - #### broadcastSound

          public void broadcastSound(int par1,
                            int par2,
                            int par3,
                            int par4,
                            int par5)

      Specified by:
        `broadcastSound` in interface `IWorldAccess`

    - #### playAuxSFX

          public void playAuxSFX(EntityPlayer par1EntityPlayer,
                        int par2,
                        int par3,
                        int par4,
                        int par5,
                        int par6)

      Plays a pre-canned sound effect along with potentially auxiliary data-driven one-shot behaviour (particles, etc).
      Specified by:
        `playAuxSFX` in interface `IWorldAccess`

    - #### destroyBlockPartially

          public void destroyBlockPartially(int par1,
                                   int par2,
                                   int par3,
                                   int par4,
                                   int par5)

      Starts (or continues) destroying a block with given ID at the given coordinates for the given partially destroyed value
      Specified by:
        `destroyBlockPartially` in interface `IWorldAccess`

    - #### registerDestroyBlockIcons

          public void registerDestroyBlockIcons(IconRegister par1IconRegister)